Codeforces Round #347 (Div. 2)

 

unrating的一场CF

A - Complicated GCD

#include <bits/stdc++.h>

const int N = 1e5 + 5;
char a[105], b[105];

bool equal() {
    int lena = strlen (a);
    int lenb = strlen (b);
    if (lena != lenb) {
        return false;
    }
    for (int i=0; i<lena; ++i) {
        if (a[i] != b[i]) {
            return false;
        }
    }
    return true;
}

int main() {
    scanf ("%s%s", a, b);
    if (equal ()) {
        printf ("%s\n", a);
    } else {
        puts ("1");
    }

    return 0;
}

贪心 B - Rebus

取最小最大,从最大调到n

#include <bits/stdc++.h>

const int N = 1e3 + 5;
char str[N];
int n, x, y;

int main() {
    gets (str);
    int len = strlen (str);
    x = 1; y = 0;
    for (int i=0; i<len; ++i) {
        if (str[i] == '+') {
            x++;
        } else if (str[i] == '-') {
            y++;
        } else if (str[i] >= '0' && str[i] <= '9') {
            n = n * 10 + (str[i] - '0');
        }
    }
    int mx = x * n - y;
    int mn = x - n * y;
    if (n > mx || n < mn) {
        puts ("Impossible");
    } else {
        int f = 0, sp = 0;
        int xx = 0, yy = 0, now = mx;
        while (now > n) {
            if (now - n + 1 > n) {
                now -= (n - 1);
                if (xx < x) {
                    xx++;
                } else {
                    yy++;
                }
            } else {
                int d = now - n;
                if (xx < x) {
                    f = -1;
                    sp = n - d;
                } else {
                    f = 1;
                    sp = 1 + d;
                }
                break;
            }
        }
        puts ("Possible");
        for (int i=0; i<len; ++i) {
            if (str[i] == '?') {
                if (i == 0) {
                    if (f == -1) {
                        printf ("%d", sp);
                        f = 0;
                    } else if (xx > 0) {
                        printf ("1");
                        xx--;
                    } else {
                        printf ("%d", n);
                    }
                } else {
                    if (str[i - 2] == '+') {
                        if (f == -1) {
                            printf ("%d", sp);
                            f = 0;
                        } else if (xx > 0) {
                            printf ("1");
                            xx--;
                        } else {
                            printf ("%d", n);
                        }   
                    } else {
                        if (f == 1) {
                            printf ("%d", sp);
                            f = 0;
                        } else if (yy > 0) {
                            printf ("%d", n);
                            yy--;
                        } else {
                            printf ("1");
                        }
                    }
                }
            } else {
                printf ("%c", str[i]);
            }
        }
        puts ("");
    }

    return 0;
}

贪心 C - International Olympiad

头晕,看不懂题意

Consider the abbreviations that are given to the first Olympiads. The first 10 Olympiads (from year 1989 to year 1998) receive one-digit abbreviations (IAO'9, IAO'0, ..., IAO'8). The next 100 Olympiads (1999 - 2098) obtain two-digit abbreviations, because all one-digit abbreviations are already taken, but the last two digits of 100 consecutive integers are pairwise different. Similarly, the next 1000Olympiads get three-digit abbreviations and so on.

Now examine the inversed problem (extract the year from an abbreviation). Let the abbreviation have k digits, then we know that all Olympiads with abbreviations of lengths (k - 1), (k - 2), ..., 1 have passed before this one. The number of such Olympiads is10k - 1 + 10k - 2 + ... + 101 = F and the current Olympiad was one of the 10k of the following. Therefore this Olympiad was held in years between (1989 + F) and (1989 + F + 10k - 1). As this segment consists of exactly 10k consecutive natural numbers, it contains a single number with a k-digit suffix that matches the current abbreviation. It is also the corresponding year.

#include <bits/stdc++.h>

char str[20];

int main() {
    int n; scanf ("%d", &n);
    for (int i=0; i<n; ++i) {
        scanf ("%s", str);
        int len = strlen (str + 4);
        int year = atoi (str + 4);
        int add = 0, tenpow = 10;
        for (int j=1; j<len; ++j) {
            add += tenpow;
            tenpow *= 10;
        }
        while (year < 1989 + add) {
            year += tenpow;
        }
        printf ("%d\n", year);
    }

    return 0;
}

  

 

转载于:https://www.cnblogs.com/Running-Time/p/5409463.html

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
项目:使用 JavaScript 编写的杀死幽灵游戏(附源代码) 杀死鬼魂游戏是使用 Vanilla JavaScript、CSS 和 HTML 画布开发的简单项目。这款游戏很有趣。玩家必须触摸/杀死游荡的鬼魂才能得分。您必须将鼠标悬停在鬼魂上 - 尽量得分。鬼魂在眨眼间不断从一个地方移动到另一个地方。您必须在 1 分钟内尽可能多地杀死鬼魂。 游戏制作 这个游戏项目只是用 HTML 画布、CSS 和 JavaScript 编写的。说到这个游戏的特点,用户必须触摸/杀死游荡的幽灵才能得分。游戏会根据你杀死的幽灵数量来记录你的总分。你必须将鼠标悬停在幽灵上——尽量得分。你必须在 1 分钟内尽可能多地杀死幽灵。游戏还会显示最高排名分数,如果你成功击败它,该分数会在游戏结束屏幕上更新。 该游戏包含大量的 javascript 以确保游戏正常运行。 如何运行该项目? 要运行此游戏,您不需要任何类型的本地服务器,但需要浏览器。我们建议您使用现代浏览器,如 Google Chrome 和 Mozilla Firefox。要玩游戏,首先,单击 index.html 文件在浏览器中打开游戏。 演示: 该项目为国外大神项目,可以作为毕业设计的项目,也可以作为大作业项目,不用担心代码重复,设计重复等,如果需要对项目进行修改,需要具备一定基础知识。 注意:如果装有360等杀毒软件,可能会出现误报的情况,源码本身并无病毒,使用源码时可以关闭360,或者添加信任。
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值